/*  Sketch zur Darstellung von Elementarzelle und Gitter eines Diamanten
Zu Beginn wird eine Elementarzelle gezeichnet
Falls das Programmfenster aktiviert ist (darauf klicken) können durch entsprechenden Tastendruck
folgende Befehle ausgeführt werden:
Taste '1'        Eine Elementarzelle (EZ) 
Taste '2'        2^3 = 8 EZ
Taste '3'        3^3 =  27 EZ
Taste 'k'        Würfelkanten einer EZ löschen / zeichnen
Taste 'e'        Farbe der Verbindungen ändern
Taste 'f'        Farben der Würfel ändern
Taste 'v'        Verbindungen als Zylinder zeichnen / löschen
Taste 'l'        Verbindungen als Linien zeichnen / löschen
Taste 'g'        Gitter drehen / nicht drehen
Taste 'x'        Würfel um x-Achse drehen /nicht drehen
Taste 'y'        Würfel um y-Achse drehen /nicht drehen
Taste 'z'        Würfel um z-Achse drehen /nicht drehen
Taste 'h'        Hintergrundfarbe hell
Taste 'b'        Hintergrundfarbe schwarz
Taste 's'        Bild speichern

Erzänzung zu "Programmieren lernen mit Computergrafik" - Oliver Deußen,Thomas Ningelgen */

float s;//Einheitszellen Dimension
float t;//s/2
float d;//Kantenlänge Würfel
float hoehe;
float w;//Linienbreite
float bmX,bmY,bmZ;//Rotation gesamt
float bcX,bcY,bcZ;//Rotationen der Cubes
float X,Y,Z; //Sphäre
float R; //Radius des Pfades auf der Sphäre
float W1,W2; //Winkel für Sphäre
color[]f = new color[8];//Farbe für die Tetraeder
color[]eckenFarben = new color[27];//maximal 27
color[]mittenFarben = new color[27];
color[]innenFarben = new color[27];
color verbindungsFarbe;
color hintergrundFarbe;
boolean kZ;
boolean eineEZ, achtEZ, szEZ;
boolean gitterDrehen;
boolean cUmXAchseD;
boolean cUmYAchseD;
boolean cUmZAchseD;
boolean zylZeichnen;
boolean linZeichnen;
boolean hintergrundSchwarz;
float winkel = 0;//Winkelfortschritt beim Zeichnen der Zylinder
float wz = 0;//Winkel Diagonale
int anzahlPunkte; 
int eZaehlen,mZaehlen,iZaehlen;//verwendet, um jeder neuen Elementarzelle andere Farben zuzuordnen
int transparenz;
float radius=1;//Radius Zylinde
float  py1,pz1,py2,pz2 ;//Koord. für die Kreise
 


void setup() {
  size(1200, 1200, P3D);
  colorMode(HSB);
  zylZeichnen=true;
  verbindungsFarbe = color(random(255),random(100,255),255);
  hintergrundFarbe = color(random(255),100,255);
  for(int i=0;i<27;i++) eckenFarben[i]  = color(random(0,70),255,random(150,255));  
  for(int i=0;i<27;i++) mittenFarben[i] = color(random(80,150),255,random(150,255));  
  for(int i=0;i<27;i++) innenFarben[i]  = color(random(160,230),255,random(150,255));  
  eZaehlen =0;mZaehlen=0;iZaehlen=0;
  s=400; t=s/2;
  R=250;W1=0;W2=0;
  anzahlPunkte = 36;
  w=6;
  bmX = 0; bmY = 0; bmZ = 0;
  bcX = 0; bcY = 0; bcZ = 0;
  kZ = false;//Kanten des Würfels werden gezeichnet
  eineEZ = false;//eine Elementarzelle
  achtEZ = true;//Gitter aus 8 EZ
  szEZ = false;//Gitter mit 27 EZ
  gitterDrehen = true;
  cUmXAchseD = true;
  cUmYAchseD = true;
  cUmZAchseD = true;  
  zylZeichnen = false;
  linZeichnen = false;
  hintergrundSchwarz = true;
  transparenz = 160;
  hoehe = sqrt(3)*t; //Halbe Diagonalen-Länge = Länge aller Verbindungen
  winkel = 360/anzahlPunkte;
  wz = atan(1/sqrt(2)); 
}

void draw(){
  if(hintergrundSchwarz)background(0);
  else background(hintergrundFarbe);
  directionalLight(0, 0, 255, 0, 0, -1);
  directionalLight(0, 0, 255,-1, 0,  0);
  directionalLight(0, 0, 255, 1, 0,  0);
  directionalLight(0, 0, 255, 0,-1,  0);
  directionalLight(0, 0, 255, 0, 1,  0);
  X=R*sin(W1)*cos(W2);
  Y=R*cos(W1)*sin(W2);
  Z=R*cos(W2);
  W1=W1+0.01;
  W2=W2+0.007;
  translate(600+X,600+Y,Z);
  bmX=bmX+0.001;
  bmY=bmY+0.0007;
  bmZ=bmZ+0.0005;
  if(gitterDrehen){
    rotateX(bmX);
    rotateY(bmY);  
    rotateZ(bmZ);
  }
  bcX = bcX+0.09;   
  bcY = bcX+0.12;  
  bcZ = bcZ+0.15;   
   
  if(eineEZ){
    s=500; t=s/2;d=70;hoehe = sqrt(3)*t;
    radius =4; w =5;
    gitterZeichnen(0,0,0);
  }
   else if(achtEZ){
      s=400; t=s/2;d=50  ; hoehe = sqrt(3)*t;
      radius =3; w=4;
      int nummerieren = 0;
      for(int i=0; i<2;i++){
        for(int j=0; j<2;j++){
          for(int k=0; k<2;k++){
              eZaehlen=nummerieren;
              mZaehlen=nummerieren;
              iZaehlen=nummerieren;
              gitterZeichnen(i,j,k);
              nummerieren++;              
          }      
         }    
      } 
  }else if(szEZ){
    s=250; t=s/2;d=40;hoehe = sqrt(3)*t;
    radius =2; w=2;
    int nummerieren = 0;
    for(int i=-1; i<2;i++){
      for(int j=-1; j<2;j++){
        for(int k=-1; k<2;k++){
            gitterZeichnen(i,j,k);
            eZaehlen=nummerieren;
            mZaehlen=nummerieren;
            iZaehlen=nummerieren;
            gitterZeichnen(i,j,k);
            nummerieren++;
        }      
      }    
    } 
  }
}

void gitterZeichnen(int X, int Y, int Z){
  if(achtEZ) translate(X*s-t,Y*s-t,Z*s-t);//Zentrum im Gitterzentrum
  else translate(X*s,Y*s,Z*s);
  noFill();
  if(kZ) stroke(200);//Kanten der Elementarzelle
  else noStroke();
  box(s);
  if(zylZeichnen)verbZylZeichnen();
  if(linZeichnen)verbLinZeichnen();
  strokeWeight(1);
  stroke(0);
  atomeZeichnen(X,Y,Z); 
  if(achtEZ) translate(-X*s+t,-Y*s+t,-Z*s+t);
  else translate(-X*s,-Y*s,-Z*s);
}

void verbZylZeichnen(){
  for(int i=0;i<16;i++){
   pushMatrix();
     mantelZeichnen(i,anzahlPunkte,hoehe/4,radius);
   popMatrix();
  }
}
//Verbindungslinien als Zylinder
void mantelZeichnen(int zylNummer,int anzahlPunkte,float hoehe,float radius){

 //fill(verbindungsFarbe);
 stroke(verbindungsFarbe);
 switch(zylNummer){
   
 case 0:  
   rotateY(PI/4);
   rotateZ(wz);  
   translate(-3*hoehe,0,0); 
   break;
   
 case 1:  
   rotateY(PI/4);
   rotateZ(-wz); 
   translate(3*hoehe,0,0); 
   break;
   
 case 2:  
   rotateY(-PI/4);
   rotateZ(-wz); 
   translate(-3*hoehe,0,0); 
   break;
   
 case 3:  
   rotateY(-PI/4);
   rotateZ(wz); 
   translate(3*hoehe,0,0); 
   break;
   
 case 4:  
   translate(0,-t,0);
   rotateY(PI/4);
   rotateZ(-wz); 
   translate(-hoehe,0,0); 
   break;
   
 case 5:  
   translate(0,-t,0);
   rotateY(PI/4);
   rotateZ(wz);  
   translate(hoehe,0,0); //print(3*hoehe+"  ");
   break;
   
 case 6:  
   translate(t,0,0);
   rotateY(-PI/4);
   rotateZ(wz); 
   translate(-hoehe,0,0); 
   break;
   
 case 7:  
   translate(t,0,0);
   rotateY(PI/4);
   rotateZ(-wz); 
   translate(-hoehe,0,0); 
   break;
   
 case 8:  
   translate(0,t,0);
   rotateY(-PI/4);
   rotateZ(wz); 
   translate(-hoehe,0,0); //print(3*hoehe+"  ");
   break;
   
 case 9:  
   translate(0,t,0);
   rotateY(-PI/4);
   rotateZ(-wz); 
   translate(hoehe,0,0); 
   break;
   
 case 10:  
   translate(0,0,t);
   rotateY(PI/4);
   rotateZ(wz);  
   translate(hoehe,0,0); //print(3*hoehe+"  ");
   break;
   
 case 11:  
   translate(0,0,t);
   rotateY(-PI/4);
   rotateZ(wz); 
   translate(-hoehe,0,0); 
   break;
   
 case 12:  
   translate(-t,0,0);
   rotateY(PI/4);
   rotateZ(wz);  
   translate(hoehe,0,0); //print(3*hoehe+"  ");
   break;
 
 case 13:  
   translate(-t,0,0);
   rotateY(-PI/4);
   rotateZ(-wz); 
   translate(hoehe,0,0); 
   break;
   
 case 14:  
   translate(0,0,-t);
   rotateY(-PI/4);
   rotateZ(-wz); 
   translate(hoehe,0,0); 
   break;
   
 case 15:  
   translate(0,0,-t);
   rotateY(PI/4);
   rotateZ(-wz); 
   translate(-hoehe,0,0); 
   
 }
 
 beginShape(QUAD_STRIP);
     for (int i=0; i<=anzahlPunkte+1; i++){  
        
       py1 = cos(radians(i*winkel))*radius;
       pz1 = sin(radians(i*winkel))*radius;  
       vertex(hoehe,py1, pz1);
        
       py2 = cos(radians(i*winkel))*radius;
       pz2 = sin(radians(i*winkel))*radius;
       vertex(-hoehe,py2,pz2);
     }
   endShape();
}

void verbLinZeichnen(){
  strokeWeight(6);
  if(hintergrundSchwarz) stroke(255);
  else stroke(0);
  line(-s/2,s/2,-s/2,-s/4,s/4,-s/4);
  line(0,s/2,0,-s/4,s/4,-s/4);
  line(-s/2,0,0,-s/4,s/4,-s/4);
  line(0,0,-s/2,-s/4,s/4,-s/4);
  
  line(s/2,-s/2,-s/2,s/4,-s/4,-s/4);
  line(0,-s/2,0,s/4,-s/4,-s/4);
  line(0,0,-s/2,s/4,-s/4,-s/4);
  line(s/2,0,0,s/4,-s/4,-s/4);
  
  line(s/2,s/2,s/2,s/4,s/4,s/4);
  line(0,s/2,0,s/4,s/4,s/4);
  line(s/2,0,0,s/4,s/4,s/4);
  line(0,0,s/2,s/4,s/4,s/4);
  
  line(-s/2,-s/2,s/2,-s/4,-s/4,s/4);
  line(0,-s/2,0,-s/4,-s/4,s/4);
  line(-s/2,0,0,-s/4,-s/4,s/4);
  line(0,0,s/2,-s/4,-s/4,s/4);
}

void atomeZeichnen(int X, int Y, int Z){
  strokeWeight(1);
  
  //Vier Atome auf den Ecken des Würfels  
  pushMatrix();
    eckAtomeZeichnen();
  popMatrix(); 
  
 //Sechs Atome zentriert auf den Flächen des Würfels
  pushMatrix();
    seitenMittenAtomeZeichnen();
  popMatrix(); 
  
  //Vier Atome auf 1/4 bzw 3/4 Raumdiagonale
  pushMatrix();
      innenAtomeZeichnen(); 
  popMatrix();
}

void cubesUmXAchseDrehen(){
   if(cUmXAchseD) rotateX(bcX);
}

void cubesUmYAchseDrehen(){
    if(cUmYAchseD)  rotateY(bcY); 
}

void cubesUmZAchseDrehen(){
    if(cUmZAchseD) rotateZ(bcZ);
}

void eckAtomeZeichnen(){     
      stroke(eckenFarben[eZaehlen]);
      fill(eckenFarben[eZaehlen],transparenz);
      pushMatrix();
       translate(t,t,t);            
       cubesUmXAchseDrehen();
       box(d);
      popMatrix(); 
      
      pushMatrix();
       translate(-t,t,-t);      
       cubesUmXAchseDrehen();
       box(d);
      popMatrix(); 
      
      pushMatrix();
       translate(-t,-t,t);        
       cubesUmXAchseDrehen();
       box(d);
      popMatrix(); 
      
      pushMatrix();
       translate(t,-t,-t);      
       cubesUmXAchseDrehen();
       box(d);
      popMatrix();       
}

void seitenMittenAtomeZeichnen(){
    stroke(mittenFarben[mZaehlen]);
    fill(mittenFarben[mZaehlen],transparenz);
    pushMatrix();   
      translate(0,0,t);
      cubesUmYAchseDrehen();
      box(d);
    popMatrix(); 
    
    pushMatrix();
      translate(0,0,-t);
      cubesUmYAchseDrehen();
      box(d);
    popMatrix(); 
    
    pushMatrix();
      translate(-t,0,0);
      cubesUmYAchseDrehen();
      box(d);
    popMatrix(); 
    
    pushMatrix();
      translate(t,0,0);
      cubesUmYAchseDrehen();
      box(d);
    popMatrix(); 
    
    pushMatrix();
      translate(0,t,0);
      cubesUmYAchseDrehen();
      box(d);
    popMatrix(); 
    
    pushMatrix();
      translate(0,-t,0);
      cubesUmYAchseDrehen();
      box(d);
    popMatrix();
      
}

void innenAtomeZeichnen(){
    stroke(innenFarben[iZaehlen]);
    fill(innenFarben[iZaehlen],transparenz);
    pushMatrix();
      translate(-t/2,-t/2,t/2);
      cubesUmZAchseDrehen();
      box(d);
    popMatrix(); 
    
    pushMatrix();
      translate(-t/2,t/2,-t/2);
      cubesUmZAchseDrehen();
      box(d);
    popMatrix(); 
    
    pushMatrix();
      translate(t/2,-t/2,-t/2);
      cubesUmZAchseDrehen();
      box(d);
    popMatrix(); 
    
    pushMatrix();
      translate(t/2,t/2,t/2);
      cubesUmZAchseDrehen();
      box(d);
    popMatrix(); 
  
}

void keyPressed(){
   if (key == 'k')kZ=!kZ;
   if (key == '1')eineEZ = true;
   if (key == '2'){achtEZ = true;eineEZ=false;}
   if (key == '3'){eineEZ = false;achtEZ = false;szEZ=true;;s=100;}
   if (key == 'f')verbindungsFarbe = color(random(255),255,100);
   if (key == 'h'){hintergrundFarbe = color(random(255),50,255);hintergrundSchwarz = false;}
   if (key == 'b')hintergrundSchwarz=true;
   if (key == 'g')gitterDrehen=!gitterDrehen;
   if (key == 'x')cUmXAchseD = !cUmXAchseD;
   if (key == 'y')cUmYAchseD = !cUmYAchseD;
   if (key == 'z')cUmZAchseD = !cUmZAchseD;
   if (key == 'v'){zylZeichnen = !zylZeichnen; linZeichnen = false;}
   if (key == 'l'){linZeichnen = !linZeichnen; zylZeichnen = false;}
   if(key  == 's') save("gitter.jpg"); 
   if (key == 'e'){
       for(int i=0;i<27;i++) eckenFarben[i] = color(random(0,70),255,random(150,255));  
       for(int i=0;i<27;i++) mittenFarben[i] = color(random(80,150),255,random(150,255));  
       for(int i=0;i<27;i++) innenFarben[i] = color(random(160,230),255,random(150,255));    
   }
}
   
   
   
   
   
   
   
   
   
   
   
